'$DYNAMIC
'$INCLUDE:'lf_core_head.bas'

DIM SHARED palels

DIM formatlist$(2)
DATA "bmp","png","gif"
FOR x = 0 TO 2
    READ formatlist$(x)
NEXT

adjusttriggers = 0

CLS
PRINT "LemSet V13.3"
PRINT "Lemmings graphic set tool by namida"
PRINT
PRINT "Select an option:"
PRINT "1) Compile graphic set"
PRINT "2) Decompile graphic set"
PRINT "3) Convert extracted Cheapo style"
PRINT "4) Save default palettes"
a$ = ""
doption = 0
dbmode = 0
WHILE doption = 0
    a$ = INKEY$
    IF a$ = "1" THEN doption = 1
    IF a$ = "2" THEN doption = 2
    IF a$ = "3" THEN doption = 3
    IF a$ = "4" THEN doption = 4
    IF a$ = "*" AND dbmode = 0 THEN
        dbmode = 1
        PRINT "Debug mode activated"
        PRINT "Do not worry if you activated this"
        PRINT "by accident. It does not affect the"
        PRINT "output, it just displays useful info"
        PRINT "for fixing errors."
    END IF
WEND
PRINT
IF doption = 1 THEN GOTO compilestyle
IF doption = 2 THEN GOTO decompilestyle
IF doption = 3 THEN GOTO cheapo
IF doption = 4 THEN GOTO savepalettes
END

savepalettes:

pi = lfc_new_image(32, 1)
lfg_reset_low8
FOR x = 0 TO 6
    lfc_set_pixel pi, x, 0, lfg_active_palette(x).vga_red * 4, lfg_active_palette(x).vga_green * 4, lfg_active_palette(x).vga_blue * 4
NEXT
lfc_set_pixel pi, 7, 0, 255, 0, 255
FOR x = 8 TO 31
    lfc_set_pixel pi, x, 0, 255, 255, 255
NEXT
lfc_save_image pi, "defpal_32.bmp"
lfc_images(pi, 0) = 16
lfc_save_image pi, "defpal_16.bmp"
lfc_close_image pi

pi = lfc_new_image(32, 1)
lfg_reset_low8_xmas
FOR x = 0 TO 6
    lfc_set_pixel pi, x, 0, lfg_active_palette(x).vga_red * 4, lfg_active_palette(x).vga_green * 4, lfg_active_palette(x).vga_blue * 4
NEXT
lfc_set_pixel pi, 7, 0, 255, 0, 255
FOR x = 8 TO 31
    lfc_set_pixel pi, x, 0, 255, 255, 255
NEXT
lfc_save_image pi, "defpal_xmas_32.bmp"
lfc_images(pi, 0) = 16
lfc_save_image pi, "defpal_xmas_16.bmp"
lfc_close_image pi

END

'$INCLUDE:'lemset_decompile.bas'
'$INCLUDE:'lemset_compile.bas'
'$INCLUDE:'lemset_cheapo.bas'

FUNCTION ls_strip_spaces$ (instr$)
a$ = instr$
WHILE LEFT$(a$, 1) = " "
    a$ = MID$(a$, 2)
WEND
WHILE RIGHT$(a$, 1) = " "
    a$ = LEFT$(a$, LEN(a$) - 1)
WEND
ls_strip_spaces$ = a$
END FUNCTION

'$INCLUDE:'lf_core_foot.bas'
