cheapo:

Input "Output style name? ", osn$

grfile = lfc_new_file(inname$ + "g_" + osn$ + ".dat")
lfc_small_endian grfile

lfg_reset_low8

palels = 16
palbit = 19
for x = 1 to 7
  lfg_active_palette(x+7) = lfg_active_palette(x)
next

lfg_active_palette(7) = lfg_active_palette(0)
lfg_active_palette(15) = lfg_active_palette(1)

lfr_save_palette grfile

tgfile = lfc_new_file(inname$ + "vgagrX.dat.0")
tgposit = 0
DIM putdat AS lfr_terrain_data

open "Graphics.sprites.xml" for binary as 1
terimg = lfc_load_image("Graphics.png")

Print "Loading terrain..."

for dopiece = 0 to 127
  a$ = ""
	b$ = " "
	while a$ <> "<Sprite "
	  get 1,,b$
		if b$ = "<" then
		  a$ = "<"
		else
		  a$ = a$ + b$
		end if
		if EOF(1) then
		  Print "  All pieces loaded."
			exit for
		end if
	wend
	
	Print "  Loading piece" + str$(dopiece) + "..."
	
	a$ = ""
	b$ = " "
	while right$(a$,8) <> "StartX='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	StartX = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,8) <> "StartY='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	StartY = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,7) <> "Width='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	Width = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,8) <> "Height='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	Height = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,7) <> "Metal='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	if a$ = "True" then
	  Metal = 1
	else
	  Metal = 0
	end if
	
	if dbmode = 1 then
	  Print "      X:" + str$(StartX) + "  Y:" + str$(StartY)
		Print "      W:" + str$(Width) + "  H:" + str$(Height)
		Print "      M:" + str$(Metal)
	end if
	
		
	putdat.width = (int((Width-1) / 8) + 1) * 8
	putdat.height = Height
	putdat.image_loc = tgposit mod 65536
	putdat.unknown1 = int(tgposit / 65536) * 2
  putdat.mask_loc = tgposit mod 65536
	putdat.unknown1 = putdat.unknown1 + (int(tgposit / 65536) * 256)	
	if Metal = 1 then putdat.unknown1 = putdat.unknown1 + 1
	if dbmode = 1 then Print "      Metadata prepared"
	tim = lfc_sect_image(terimg, StartX, StartY, Width, Height)
	if dbmode = 1 then Print "      Image sected"
	tgposit = lfg_encode_image(tim, tgfile, tgposit, palbit, 0)
	if dbmode = 1 then Print "      Image encoded"
	lfr_put_terrain grfile, dopiece, putdat
	if dbmode = 1 then Print "      Metadata encoded"
	lfc_close_image tim
next

lfc_close_image terimg
close 1


Print "Grabbing object image metadata..."
open "Objects.sprites.xml" for binary as 1

objims = 0
a$ = ""
b$ = " "

while not eof(1)
  get 1,,b$
	if b$ = "<" then
	  a$ = "<"
	else
	  a$ = a$ + b$
	end if
	if a$ = "<Sprite Index=" then
	  objims = objims + 1
		a$ = ""
	end if
wend

objims = objims - 1

seek 1, 1

dim obj_meta(objims, 3)

for x = 0 to objims
  Print "  Loading image" + str$(x) + "..."
  a$ = ""
	b$ = " "
	while a$ <> "<Sprite "
	  get 1,,b$
		if b$ = "<" then
		  a$ = "<"
		else
		  a$ = a$ + b$
		end if
	wend
	
	a$ = ""
	b$ = " "
	while right$(a$,8) <> "StartX='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	obj_meta(x, 0) = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,8) <> "StartY='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	obj_meta(x, 1) = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,7) <> "Width='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	obj_meta(x, 2) = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,8) <> "Height='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	obj_meta(x, 3) = val(a$)
	
next

close 1

PRINT "Encoding objects..."
ogfile = lfc_new_file(inname$ + "vgagrX.dat.1")
objsimg = lfc_load_image("Objects.png")
ogposit = 0
DIM putdat2 AS lfr_object_data

open "Objects.objects.xml" for binary as 1

for doobj = 0 to 31
  
	a$ = ""
	b$ = " "
	while a$ <> "<Object "
	  get 1,,b$
		if b$ = "<" then
		  a$ = "<"
		else
		  a$ = a$ + b$
		end if
		if eof(1) then
		
		  Print "All objects converted or maximum object number reached."
			exit for
		end if
	wend
	
	Print "  Object" + str$(doobj) + "..."
	
	circ = 0
	
	a$ = ""
	b$ = " "
	while right$(a$,6) <> "Type='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	maintype$ = a$
	
	a$ = ""
	b$ = " "
	while right$(a$,9) <> "SubType='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	subtype$ = a$
	
	a$ = ""
	b$ = " "
	while right$(a$,13) <> "SpriteStart='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	spritestart = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,13) <> "SpriteCount='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	spritecount = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,10) <> "HitRectX='"
	  get 1,,b$
		a$ = a$ + b$
	  if right$(a$, 12) = "HitCircleX='" then
	    circ = 1
		exit while
	  end if
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	hrx = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,10) <> "HitRectY='"
	  get 1,,b$
		a$ = a$ + b$
	  if right$(a$, 12) = "HitCircleY='" then exit while
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	hry = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,14) <> "HitRectWidth='"
	  get 1,,b$
		a$ = a$ + b$
	  if right$(a$, 17) = "HitCircleRadius='" then exit while
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	hrw = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,15) <> "HitRectHeight='" and circ = 0
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'" and circ = 0
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	hrh = val(a$)
	
	if circ = 1 then
	  hrx = hrx - hrw + 1
	  hry = hry - hrw + 1
	  hrw = (hrw * 2) - 1
	  hrh = hrw
	  circ = 0
	end if
	
	a$ = ""
	b$ = " "
	while right$(a$,11) <> "HitPointX='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	hpx = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,11) <> "HitPointY='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	hpy = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,7) <> "Sound='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	soundfx = val(a$)
	
	' maintype$, subtype$
	' spritestart, spritecount
	' hrx, hry, hrw, hrh
	' hpx, hpy
	' soundfx
	
	lfr_set_defaults putdat2
	putdat2.end_animation_frame_index = spritecount
	putdat2.start_animation_frame_index = 0
	putdat2.animation_frames_base_loc = ogposit mod 65536
	putdat2.unknown1 = int(ogposit / 65536)
	
	IF putdat2.end_animation_frame_index > 1 THEN putdat2.animation_flags = 2
	IF maintype$ = "Activate" then putdat2.animation_flags = 1
	
	' trigger type, rect, sound
	
	foundtype = 0
	
	if maintype$ = "Window" then
	  lfr_set_window_values putdat2
		putdat2.trigger_effect_id = 23
		
		hrx = hpx
		hry = hpy - 2
		hrw = 1
		hrh = 1
		
		if dbmode = 1 then
		  Print "      HPX:" + str$(hpx) + "  HPY:" + str$(hpy)
			Print "      HRX:" + str$(hrx) + "  HRY:" + str$(hry)
		end if
		
		foundtype = 1
	end if
	
	' Types to cover
'
' Window   > None       :: 23
' Activate > Death      ::  4
' Activate > Harmless   ::  0  >> 24
' Activate > Exit       ::  1
' Activate > Teleporter :: 11
' Activate > Receiver   :: 12
' Activate > TwoWayTeleporter :: Not supported >> 28
' Activate > SingleTeleporter :: Not supported >> 29
' Activate > GravUp     :: Not supported
' Activate > GravDown   :: Not supported
' Constant > Exit       ::  1
' Constant > Water      ::  5
' Constant > Fire       ::  6
' Constant > Harmless   ::  0
' Constant > GravUp     :: Not supported
' Constant > GravDown   :: Not supported
' Constant > Hint       ::  0 >> 25
' Constant > Splat      :: Not supported >> 27
' Constant > NoSplat    :: 20 >> 26
	
	if maintype$ = "Activate" then
	    putdat2.animation_flags = 1
	    if subtype$ = "TwoWayTeleporter" then putdat2.trigger_effect_id = 28
        if subtype$ = "SingleTeleporter" then putdat2.trigger_effect_id = 29
		if subtype$ = "TwoWayTeleporter" or subtype$ = "SingleTeleporter" then
		  putdat2.trigger_px = hpx
		  putdat2.trigger_py = hpy
		end if
	    if subtype$ = "GravityUp" or subtype$ = "GravityDown" then
		    Print "    NOTE: Object type not supported in NeoLemmix. The object will"
			Print "          be converted but will not be functional."
			putdat2.trigger_effect_id = 24
		end if
		if subtype$ = "Exit" then putdat2.trigger_effect_id = 1
		if subtype$ = "Death" then putdat2.trigger_effect_id = 4
		if subtype$ = "Teleporter" then  putdat2.trigger_effect_id = 11
	    if subtype$ = "Harmless" then putdat2.trigger_effect_id = 24
		if subtype$ = "Receiver" then
		    putdat2.trigger_effect_id = 12
		    hrx = hpx
			hry = hpy
			hrw = 1
			hrh = 1
			kf = spritecount - 1
		else 
	        kf = 0
		end if
		if subtype$ = "Death" or subtype$ = "Teleporter" then
		  select case soundfx
			  case 17: putdat2.trap_sound_effect_id = 14
				case 16: putdat2.trap_sound_effect_id = 7
				case 14: putdat2.trap_sound_effect_id = 15
				case 15: putdat2.trap_sound_effect_id = 9
				case else: putdat2.trap_sound_effect_id = 6
			end select
		end if
	end if
	
	if maintype$ = "Constant" then
	  if spritecount > 1 then putdat2.animation_flags = 2
		if subtype$ = "GravityUp" or subtype$ = "GravityDown" then
		  Print "    NOTE: Object type not supported in NeoLemmix. The object will"
			Print "          be converted but will not be functional."
			foundtype = 1
		end if
		if subtype$ = "Exit" then putdat2.trigger_effect_id = 1
		if subtype$ = "Water" then putdat2.trigger_effect_id = 5
		if subtype$ = "Fire" then putdat2.trigger_effect_id = 6
		if subtype$ = "Splat" then putdat2.trigger_effect_id = 27
		if subtype$ = "NoSplat" then putdat2.trigger_effect_id = 26
		if subtype$ = "Hint" then putdat2.trigger_effect_id = 25
		if subtype$ = "Harmless" then foundtype = 1
	end if
	
	if putdat2.trigger_effect_id = 0 and foundtype = 0 then
	  Print "WARNING: Unknown type:   " + maintype$ + " : " + subtype$
	  Print "         Will convert as no-effect object. Press any key to continue."
	  if maintype$ = "Activate" then putdat2.trigger_effect_id = 24
	  sleep
	end if
	
	if putdat2.trigger_effect_id <> 0 then
	  hry = hry + 1
	
	  putdat2.trigger_left = INT((hrx + 3) / 4)
		putdat2.trigger_top = INT((hry + 3) / 4) + 1
		putdat2.trigger_width = INT((hrw + 3) / 4)
		putdat2.trigger_height = INT((hrh + 3) / 4)
		
		txoff = (4 - ABS(hrx MOD 4)) MOD 4
    tyoff = (4 - ABS(hry MOD 4)) MOD 4
    twoff = (4 - ABS(hrw MOD 4)) MOD 4
    thoff = (4 - ABS(hrh MOD 4)) MOD 4
		
		putdat2.unknown3 = thoff + (twoff * 4) + (tyoff * 16) + (txoff * 64) + (kf * 256)
	end if
	
	mx = 0
	my = 0
	for r = 0 to (spritecount - 1)
	  if obj_meta(r + spritestart, 2) > mx then mx = obj_meta(r + spritestart, 2)
		if obj_meta(r + spritestart, 3) > my then my = obj_meta(r + spritestart, 3)
	next
  mx = (int((mx - 1) / 8) + 1) * 8
	
	putdat2.unknown2 = mx - obj_meta(spritestart, 2)
	
	oim = lfc_new_image(mx, my * spritecount)
	'for r = 0 to (spritecount - 1)
	'  imnum = spritestart + r
	'	kim = lfc_sect_image(objsimg, obj_meta(imnum, 0), obj_meta(imnum, 1), obj_meta(imnum, 2), obj_meta(imnum, 3))
	'	lfc_clone_image kim, oim, 0, (r * my)
	'	lfc_close_image kim
	'next
	
	'lfc_save_image oim, "temp.bmp"
	
	lfr_set_obj_values_from_image oim, putdat2
  lfr_set_obj_deriv_values putdat2, palbit
	lfr_set_preview_image 0, putdat2
	
	lfc_close_image oim
	
	FOR q = 1 TO putdat2.end_animation_frame_index
	  if maintype$ = "Window" then
		  if q = 1 then
			  imnum = spritestart + spritecount - 1
			else
			  imnum = spritestart + q - 2
			end if
		else
	    imnum = spritestart + q - 1
		end if
    tmoim = lfc_sect_image(objsimg, obj_meta(imnum, 0), obj_meta(imnum, 1), obj_meta(imnum, 2), obj_meta(imnum, 3))
		for dx = 0 to mx-1
		  for dy = 0 to my - 1
			  if (dx >= lfc_images(tmoim, 0)) or (dy >= lfc_images(tmoim, 1)) then lfc_set_pixel tmoim, dx, dy, 0, 0, 0
			next
		next
		lfc_images(tmoim, 0) = mx
		lfc_images(tmoim, 1) = my
    ogposit = lfg_encode_image(tmoim, ogfile, ogposit, palbit, 0)
    ogposit = lfg_encode_image(tmoim, ogfile, ogposit, 1, 1)
    lfc_close_image tmoim
  NEXT
	
  lfr_put_object grfile, doobj, putdat2
 
next

close 1

if doobj <= 30 then

  Print "Generating one-way arrow objects..."

  if doobj <= 29 then
	  do_owd = 1
	else
	  Print "  Not enough space to include one-way down arrows."
		Print "  Will only generate one-way left and one-way right."
	end if

  ' Make one way arrows
	open "Standards.sprites.xml" for binary as 1
	stansimg = lfc_load_image("Standards.png")
	n = 0
	a$ = ""
	b$ = " "
	while n < 58
	  get 1,,b$
		a$ = a$ + b$
		if b$ = "<" then a$ = "<"
		if a$ = "<Sprite Index" then n = n + 1
	wend
	
	a$ = ""
	b$ = " "
	while a$ <> "<Sprite "
	  get 1,,b$
		if b$ = "<" then
		  a$ = "<"
		else
		  a$ = a$ + b$
		end if
	wend
	
	a$ = ""
	b$ = " "
	while right$(a$,8) <> "StartX='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	OWL_X = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,8) <> "StartY='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	OWL_Y = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,7) <> "Width='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	OWL_W = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,8) <> "Height='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	OWL_H = val(a$)
	
	a$ = ""
	b$ = " "
	while a$ <> "<Sprite "
	  get 1,,b$
		if b$ = "<" then
		  a$ = "<"
		else
		  a$ = a$ + b$
		end if
	wend
	
	a$ = ""
	b$ = " "
	while right$(a$,8) <> "StartX='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	OWR_X = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,8) <> "StartY='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	OWR_Y = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,7) <> "Width='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	OWR_W = val(a$)
	
	a$ = ""
	b$ = " "
	while right$(a$,8) <> "Height='"
	  get 1,,b$
		a$ = a$ + b$
	wend
	
	a$ = ""
	b$ = " "
	while b$ <> "'"
	  get 1,,b$
		a$ = a$ + b$
	wend
	a$ = left$(a$, len(a$)-1)
	
	OWR_H = val(a$)
	
	close 1
	

	' Generate one-way left
	
	lfr_set_defaults putdat2
	putdat2.end_animation_frame_index = 1
	putdat2.start_animation_frame_index = 0
	putdat2.animation_frames_base_loc = ogposit mod 65536
	putdat2.unknown1 = int(ogposit / 65536)
	putdat2.trigger_effect_id = 7
	
	hrx = 0
	hry = 0
	hrw = OWL_W
	hrh = OWL_H
	putdat2.trigger_left = INT((hrx + 3) / 4)
	putdat2.trigger_top = INT((hry + 3) / 4) + 1
	putdat2.trigger_width = INT((hrw + 3) / 4)
	putdat2.trigger_height = INT((hrh + 3) / 4)
	txoff = (4 - ABS(hrx MOD 4)) MOD 4
  tyoff = (4 - ABS(hry MOD 4)) MOD 4
  twoff = (4 - ABS(hrw MOD 4)) MOD 4
  thoff = (4 - ABS(hrh MOD 4)) MOD 4
	putdat2.unknown3 = thoff + (twoff * 4) + (tyoff * 16) + (txoff * 64) + (kf * 256)
	
	mx = OWL_W
	my = OWL_H
  mx = (int((mx - 1) / 8) + 1) * 8
	
	oim = lfc_new_image(mx, my)
	
	lfr_set_obj_values_from_image oim, putdat2
  lfr_set_obj_deriv_values putdat2, palbit
	lfr_set_preview_image 0, putdat2
	
	lfc_close_image oim

  tmoim = lfc_sect_image(stansimg, OWL_X, OWL_Y, OWL_W, OWL_H)
	for dx = 0 to mx-1
		for dy = 0 to my - 1
			if (dx >= lfc_images(tmoim, 0)) or (dy >= lfc_images(tmoim, 1)) then lfc_set_pixel tmoim, dx, dy, 0, 0, 0
	  next
	next
	lfc_images(tmoim, 0) = mx
	lfc_images(tmoim, 1) = my
  ogposit = lfg_encode_image(tmoim, ogfile, ogposit, palbit, 0)
  ogposit = lfg_encode_image(tmoim, ogfile, ogposit, 1, 1)
  lfc_close_image tmoim
	
  lfr_put_object grfile, doobj, putdat2
	doobj = doobj + 1
	
	' Generate one-way right
	
	lfr_set_defaults putdat2
	putdat2.end_animation_frame_index = 1
	putdat2.start_animation_frame_index = 0
	putdat2.animation_frames_base_loc = ogposit mod 65536
	putdat2.unknown1 = int(ogposit / 65536)
	putdat2.trigger_effect_id = 8
	
	hrx = 0
	hry = 0
	hrw = OWR_W
	hrh = OWR_H
	putdat2.trigger_left = INT((hrx + 3) / 4)
	putdat2.trigger_top = INT((hry + 3) / 4) + 1
	putdat2.trigger_width = INT((hrw + 3) / 4)
	putdat2.trigger_height = INT((hrh + 3) / 4)
	txoff = (4 - ABS(hrx MOD 4)) MOD 4
  tyoff = (4 - ABS(hry MOD 4)) MOD 4
  twoff = (4 - ABS(hrw MOD 4)) MOD 4
  thoff = (4 - ABS(hrh MOD 4)) MOD 4
	putdat2.unknown3 = thoff + (twoff * 4) + (tyoff * 16) + (txoff * 64) + (kf * 256)
	
	mx = OWR_W
	my = OWR_H
  mx = (int((mx - 1) / 8) + 1) * 8
	
	oim = lfc_new_image(mx, my)
	
	lfr_set_obj_values_from_image oim, putdat2
  lfr_set_obj_deriv_values putdat2, palbit
	lfr_set_preview_image 0, putdat2
	
	lfc_close_image oim

  tmoim = lfc_sect_image(stansimg, OWR_X, OWR_Y, OWR_W, OWR_H)
	for dx = 0 to mx-1
		for dy = 0 to my - 1
			if (dx >= lfc_images(tmoim, 0)) or (dy >= lfc_images(tmoim, 1)) then lfc_set_pixel tmoim, dx, dy, 0, 0, 0
	  next
	next
	lfc_images(tmoim, 0) = mx
	lfc_images(tmoim, 1) = my
  ogposit = lfg_encode_image(tmoim, ogfile, ogposit, palbit, 0)
  ogposit = lfg_encode_image(tmoim, ogfile, ogposit, 1, 1)
  lfc_close_image tmoim
	
  lfr_put_object grfile, doobj, putdat2
	doobj = doobj + 1
	
	if do_owd = 1 then
	
	  'Generate one-way down
		
		lfr_set_defaults putdat2
		putdat2.end_animation_frame_index = 1
		putdat2.start_animation_frame_index = 0
		putdat2.animation_frames_base_loc = ogposit mod 65536
		putdat2.unknown1 = int(ogposit / 65536)
		putdat2.trigger_effect_id = 19
		
		hrx = 0
		hry = 0
		hrw = OWR_H
		hrh = OWR_W
		putdat2.trigger_left = INT((hrx + 3) / 4)
		putdat2.trigger_top = INT((hry + 3) / 4) + 1
		putdat2.trigger_width = INT((hrw + 3) / 4)
		putdat2.trigger_height = INT((hrh + 3) / 4)
		txoff = (4 - ABS(hrx MOD 4)) MOD 4
		tyoff = (4 - ABS(hry MOD 4)) MOD 4
		twoff = (4 - ABS(hrw MOD 4)) MOD 4
		thoff = (4 - ABS(hrh MOD 4)) MOD 4
		putdat2.unknown3 = thoff + (twoff * 4) + (tyoff * 16) + (txoff * 64) + (kf * 256)
		
		mx = OWR_H
		my = OWR_W
		mx = (int((mx - 1) / 8) + 1) * 8
		
		oim = lfc_new_image(mx, my)
		
		lfr_set_obj_values_from_image oim, putdat2
		lfr_set_obj_deriv_values putdat2, palbit
		lfr_set_preview_image 0, putdat2
		
		lfc_close_image oim

		tmoim2 = lfc_sect_image(stansimg, OWR_X, OWR_Y, OWR_W, OWR_H)
		tmoim = lfc_new_image(mx, my)
		for x = 0 to mx-1
		  for y = 0 to my-1
			  lfc_set_pixel tmoim, x, y, lfc_get_pixel_red(tmoim2, y, mx-x-1), lfc_get_pixel_green(tmoim2, y, mx-x-1), lfc_get_pixel_blue(tmoim2, y, mx-x-1)
			next
		next
		lfc_close_image tmoim2
		for dx = 0 to mx-1
			for dy = 0 to my - 1
				if (dx >= lfc_images(tmoim, 0)) or (dy >= lfc_images(tmoim, 1)) then lfc_set_pixel tmoim, dx, dy, 0, 0, 0
			next
		next
		lfc_images(tmoim, 0) = mx
		lfc_images(tmoim, 1) = my
		ogposit = lfg_encode_image(tmoim, ogfile, ogposit, palbit, 0)
		ogposit = lfg_encode_image(tmoim, ogfile, ogposit, 1, 1)
		lfc_close_image tmoim
		
		lfr_put_object grfile, doobj, putdat2
		doobj = doobj + 1
	
	end if

	lfc_close_image stansimg
else

  Print "Not enough space to include one-way arrows."
	
end if


'These are practically hardcoded for Cheapo styles
lfr_get_object grfile, 0, putdat2
putdat2.animation_flags = putdat2.animation_flags + 512 + 16384 + 256 + 1024 + 8192 + 32768
lfr_put_object grfile, 0, putdat2

PRINT "Saving files to disk..."

if lfc_files(grfile).size > 1056 then
  lfc_files(grfile).size = (1056 * 2)
else
  lfc_files(grfile).size = 1056
end if

vgagrfile = lfc_new_file(inname$ + "v_" + osn$ + ".dat")
lfd_encode_file vgagrfile, 0, tgfile, 0
lfd_encode_file vgagrfile, 1, ogfile, 0

lfc_save_file vgagrfile
lfc_save_file grfile
lfc_close_file grfile
lfc_close_file tgfile
lfc_close_file ogfile
lfc_close_file vgagrfile

END