' Lemmings Functions Core
' Header File

' Lemmings Functions are for easily loading and managing data from DOS Lemmings data files.
' Written by Namida Verasche. (namida_verasche@hotmail.com)


'$INCLUDE:'lf_dat_head.bas'
'$INCLUDE:'lf_gfx_head.bas'
'$INCLUDE:'lf_grd_head.bas'

const lfc_maxfiles = 7
const lfc_max_file_size = 4194304
const lfc_max_images = 3
const lfc_max_imgwidth = 10000
const lfc_max_imgheight = 10000
const lfc_max_ini = 1
const lfc_max_ini_entries = 749

dim shared lfc_images(lfc_max_images, 1) as _unsigned integer
dim shared lfc_imagedata(lfc_max_images, lfc_max_imgwidth-1, lfc_max_imgheight-1, 2) as _unsigned _byte

dim shared lfc_ini(lfc_max_ini) as _unsigned _byte
dim shared lfc_inidata(lfc_max_ini, lfc_max_ini_entries, 2) as string


type lfc_files
  name as string * 255
  in_use as _byte
  endian as _byte
  size as _unsigned long
end type

dim shared lfc_filedata(lfc_maxfiles, lfc_max_file_size) as _unsigned _byte

dim shared lfc_files(lfc_maxfiles) as lfc_files