' Lemmings Functions - Ground Tool
' Header File
' by Namida Verasche

' Ground Tool is used for reading or modifying the GROUNDxO.DAT files.

TYPE lfr_object_data
  animation_flags AS _UNSIGNED INTEGER
  start_animation_frame_index AS _UNSIGNED _BYTE
  end_animation_frame_index AS _UNSIGNED _BYTE
  width AS _UNSIGNED _BYTE
  height AS _UNSIGNED _BYTE
  animation_frame_data_size AS _UNSIGNED INTEGER
  mask_offset_from_image AS _UNSIGNED INTEGER
  unknown1 AS _UNSIGNED INTEGER
  unknown2 AS _UNSIGNED INTEGER
  trigger_left AS _UNSIGNED _BYTE
  trigger_px AS _UNSIGNED _BYTE
  trigger_top AS _UNSIGNED _BYTE
  trigger_py AS _UNSIGNED _BYTE
  trigger_width AS _UNSIGNED _BYTE
  trigger_height AS _UNSIGNED _BYTE
  trigger_effect_id AS _UNSIGNED _BYTE
  animation_frames_base_loc AS _UNSIGNED INTEGER
  preview_image_index AS _UNSIGNED INTEGER
  unknown3 AS _UNSIGNED INTEGER
  trap_sound_effect_id AS _UNSIGNED _BYTE
END TYPE

TYPE lfr_terrain_data
  width as _unsigned _byte
  height as _unsigned _byte
  image_loc as _unsigned integer
  mask_loc as _unsigned integer
  unknown1 as _unsigned integer
END TYPE