' Lemmings Functions - Graphics Tools
' Header File
' by Namida Verasche

' Graphics Tools is used for encoding or decoding graphics from the
' planar bitmap files in DOS Lemmings.

type lfg_palette_entry
  ega_value as _unsigned _byte
  vga_red as _unsigned _byte
  vga_green as _unsigned _byte
  vga_blue as _unsigned _byte
end type

dim shared lfg_active_palette(31) as lfg_palette_entry
dim shared lfg_out_pal as lfg_palette_entry
dim shared lfg_default_low8(7) as lfg_palette_entry
dim shared lfg_default_low8_xmas(7) as lfg_palette_entry
dim shared lfg_menu_pal(15) as lfg_palette_entry
dim shared transcolor(2)

transcolor(0) = 255
transcolor(1) = 0
transcolor(2) = 255

data 0, 0, 0, 0
data 0, 16, 16, 56
data 0, 0, 44, 0
data 0, 60, 52, 52
data 0, 44, 44, 0
data 0, 60, 8, 8
data 0, 32, 32, 32
data 0, 0, 0, 0

for x = 0 to 7
  lfg_default_low8(x).ega_value = lfc_read
  lfg_default_low8(x).vga_red = lfc_read
  lfg_default_low8(x).vga_green = lfc_read
  lfg_default_low8(x).vga_blue = lfc_read
next


data 0, 0, 0, 0
data 0, 52, 8, 8
data 0, 0, 44, 0
data 0, 60, 52, 52
data 0, 60, 60, 0
data 0, 16, 16, 60
data 0, 32, 32, 32
data 0, 0, 0, 0

for x = 0 to 7
  lfg_default_low8_xmas(x).ega_value = lfc_read
  lfg_default_low8_xmas(x).vga_red = lfc_read
  lfg_default_low8_xmas(x).vga_green = lfc_read
  lfg_default_low8_xmas(x).vga_blue = lfc_read
next

data 0, 0, 0, 0
data 34, 32, 16, 8
data 0, 24, 12, 8
data 0, 12, 0, 4
data 0, 8, 1, 31
data 0, 16, 11, 36
data 0, 26, 22, 41
data 0, 38, 35, 47
data 0, 0, 20, 0
data 0, 0, 24, 04
data 0, 0, 28, 8
data 0, 0, 32, 16
data 0, 52, 52, 52
data 0, 44, 44, 0
data 0, 16, 20, 44
data 0, 56, 32, 36

for x = 0 to 15
  lfg_menu_pal(x).ega_value = lfc_read
  lfg_menu_pal(x).vga_red = lfc_read
  lfg_menu_pal(x).vga_green = lfc_read
  lfg_menu_pal(x).vga_blue = lfc_read
next